﻿Imports HSCF
Imports HomeSeerAPI
Imports Scheduler
Imports HSCF.Communication.ScsServices.Service
Imports System.Reflection
Imports System.Text

Public Class HSPI
    Inherits ScsService
    Implements IPlugInAPI               ' this API is required for ALL plugins
    Public Shared bShutDown As Boolean = False
    Public OurInstanceFriendlyName As String = ""

    Public Function AccessLevel() As Integer Implements HomeSeerAPI.IPlugInAPI.AccessLevel
        Return 1
    End Function

    Public Property ActionAdvancedMode As Boolean Implements HomeSeerAPI.IPlugInAPI.ActionAdvancedMode
        Get
            Return False
        End Get
        Set(value As Boolean)

        End Set
    End Property

    Public Function ActionBuildUI(sUnique As String, ActInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As String Implements HomeSeerAPI.IPlugInAPI.ActionBuildUI
        Return ("")
    End Function

    Public Function ActionConfigured(ActInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As Boolean Implements HomeSeerAPI.IPlugInAPI.ActionConfigured
        Return False
    End Function

    Public Function ActionCount() As Integer Implements HomeSeerAPI.IPlugInAPI.ActionCount
        Return (0)
    End Function

    Public Function ActionFormatUI(ActInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As String Implements HomeSeerAPI.IPlugInAPI.ActionFormatUI
        Return ""
    End Function

    Public ReadOnly Property ActionName(ActionNumber As Integer) As String Implements HomeSeerAPI.IPlugInAPI.ActionName
        Get
            Return ""
        End Get
    End Property

    Public Function ActionProcessPostUI(PostData As System.Collections.Specialized.NameValueCollection, TrigInfoIN As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As HomeSeerAPI.IPlugInAPI.strMultiReturn Implements HomeSeerAPI.IPlugInAPI.ActionProcessPostUI
        Dim r As New IPlugInAPI.strMultiReturn
        Return r
    End Function

    Public Function ActionReferencesDevice(ActInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo, dvRef As Integer) As Boolean Implements HomeSeerAPI.IPlugInAPI.ActionReferencesDevice
        Return False
    End Function

    Public Function Capabilities() As Integer Implements HomeSeerAPI.IPlugInAPI.Capabilities
        Return HomeSeerAPI.Enums.eCapabilities.CA_IO
    End Function

    Public Property Condition(TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As Boolean Implements HomeSeerAPI.IPlugInAPI.Condition
        Get
            Return False
        End Get
        Set(value As Boolean)

        End Set
    End Property

    Public Function ConfigDevice(ref As Integer, user As String, userRights As Integer, newDevice As Boolean) As String Implements HomeSeerAPI.IPlugInAPI.ConfigDevice
        Return ""
    End Function

    Public Function ConfigDevicePost(ref As Integer, data As String, user As String, userRights As Integer) As HomeSeerAPI.Enums.ConfigDevicePostReturn Implements HomeSeerAPI.IPlugInAPI.ConfigDevicePost
        Return Enums.ConfigDevicePostReturn.DoneAndCancel
    End Function

    Public Function GenPage(link As String) As String Implements HomeSeerAPI.IPlugInAPI.GenPage
        Return ""
    End Function

    Public Function GetPagePlugin(page As String, user As String, userRights As Integer, queryString As String) As String Implements HomeSeerAPI.IPlugInAPI.GetPagePlugin
        Return ""
    End Function

    Public Function HandleAction(ActInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As Boolean Implements HomeSeerAPI.IPlugInAPI.HandleAction
        Return False
    End Function

    Public ReadOnly Property HasConditions(TriggerNumber As Integer) As Boolean Implements HomeSeerAPI.IPlugInAPI.HasConditions
        Get
            Return False
        End Get
    End Property

    Public ReadOnly Property HasTriggers As Boolean Implements HomeSeerAPI.IPlugInAPI.HasTriggers
        Get
            Return False
        End Get
    End Property

    Public ReadOnly Property HSCOMPort As Boolean Implements HomeSeerAPI.IPlugInAPI.HSCOMPort
        Get
            Return False  'We do not use a COM port, or we will get it from the user and save it using code in this plug-in.
        End Get
    End Property

    Public Sub HSEvent(EventType As HomeSeerAPI.Enums.HSEvent, parms() As Object) Implements HomeSeerAPI.IPlugInAPI.HSEvent
        Dim s As String
        Dim s1 As String
        Dim i2 As Integer
        '' Determine number of parms for each Event Type
        Select Case EventType
            Case 2
                '' Log Record
                i2 = 3
            Case 1024
                '' Value Change
                i2 = 4
            Case 64
                '' String Change
                i2 = 3
            Case Else
                Console.WriteLine("Invalid EventType received by HsEvent: " & EventType.ToString)
                Exit Sub
        End Select
        '' Build single string parm
        s = ""
        For i As Integer = 0 To i2
            s1 = ""
            If Not IsNothing(parms(i)) Then
                s1 = parms(i).ToString
            End If
            s = s & s1 & Chr(2)
        Next
        '' Call routine to handle Events on the UI thread
        If Not bShutDown Then
            theMainForm.Invoke(New UpdateDevicesDelegate(AddressOf theMainForm.UpdateDevices), s)
        End If
    End Sub

    Public Function InitIO(port As Integer) As String Implements HomeSeerAPI.IPlugInAPI.InitIO
        hs.WriteLog(IFACE_NAME, "InitIO called, plug-in is being initialized...")
        ' theMainForm.MyLog("InitIO Called...")
        ' register for events from homeseer
        callback.RegisterEventCB(Enums.HSEvent.VALUE_CHANGE, IFACE_NAME, "")
        callback.RegisterEventCB(Enums.HSEvent.LOG, IFACE_NAME, "")
        callback.RegisterEventCB(Enums.HSEvent.STRING_CHANGE, IFACE_NAME, "")
        Return ""
    End Function

    Public Function InstanceFriendlyName() As String Implements HomeSeerAPI.IPlugInAPI.InstanceFriendlyName
        Return OurInstanceFriendlyName
    End Function

    Public Function InterfaceStatus() As HomeSeerAPI.IPlugInAPI.strInterfaceStatus Implements HomeSeerAPI.IPlugInAPI.InterfaceStatus
        Dim es As New IPlugInAPI.strInterfaceStatus
        es.intStatus = IPlugInAPI.enumInterfaceStatus.OK
        Return es
    End Function

    Public ReadOnly Property Name As String Implements HomeSeerAPI.IPlugInAPI.Name
        Get
            Return IFACE_NAME
        End Get
    End Property

    Public Function PagePut(data As String) As String Implements HomeSeerAPI.IPlugInAPI.PagePut
        Return ""
    End Function

    Public Function PluginFunction(procName As String, parms() As Object) As Object Implements HomeSeerAPI.IPlugInAPI.PluginFunction
        Return Nothing
    End Function

    Public Function PluginPropertyGet(procName As String, parms() As Object) As Object Implements HomeSeerAPI.IPlugInAPI.PluginPropertyGet
        Return Nothing
    End Function

    Public Sub PluginPropertySet(procName As String, value As Object) Implements HomeSeerAPI.IPlugInAPI.PluginPropertySet

    End Sub

    Public Function PollDevice(dvref As Integer) As HomeSeerAPI.IPlugInAPI.PollResultInfo Implements HomeSeerAPI.IPlugInAPI.PollDevice

    End Function

    Public Function PostBackProc(page As String, data As String, user As String, userRights As Integer) As String Implements HomeSeerAPI.IPlugInAPI.PostBackProc
        Return ""
    End Function

    Public Function RaisesGenericCallbacks() As Boolean Implements HomeSeerAPI.IPlugInAPI.RaisesGenericCallbacks
        Return False
    End Function

    Public Function Search(SearchString As String, RegEx As Boolean) As HomeSeerAPI.SearchReturn() Implements HomeSeerAPI.IPlugInAPI.Search
        Return Nothing
    End Function

    Public Sub SetIOMulti(colSend As System.Collections.Generic.List(Of HomeSeerAPI.CAPI.CAPIControl)) Implements HomeSeerAPI.IPlugInAPI.SetIOMulti

    End Sub

    Public Sub ShutdownIO() Implements HomeSeerAPI.IPlugInAPI.ShutdownIO
        bShutDown = True
    End Sub

    Public Sub SpeakIn(device As Integer, txt As String, w As Boolean, host As String) Implements HomeSeerAPI.IPlugInAPI.SpeakIn

    End Sub

    Public ReadOnly Property SubTriggerCount(TriggerNumber As Integer) As Integer Implements HomeSeerAPI.IPlugInAPI.SubTriggerCount
        Get
            Return Nothing
        End Get
    End Property

    Public ReadOnly Property SubTriggerName(TriggerNumber As Integer, SubTriggerNumber As Integer) As String Implements HomeSeerAPI.IPlugInAPI.SubTriggerName
        Get
            Return Nothing
        End Get
    End Property

    Public Function SupportsAddDevice() As Boolean Implements HomeSeerAPI.IPlugInAPI.SupportsAddDevice
        Return False
    End Function

    Public Function SupportsConfigDevice() As Boolean Implements HomeSeerAPI.IPlugInAPI.SupportsConfigDevice
        Return False
    End Function

    Public Function SupportsConfigDeviceAll() As Boolean Implements HomeSeerAPI.IPlugInAPI.SupportsConfigDeviceAll
        Return False
    End Function

    Public Function SupportsMultipleInstances() As Boolean Implements HomeSeerAPI.IPlugInAPI.SupportsMultipleInstances
        Return False
    End Function

    Public Function SupportsMultipleInstancesSingleEXE() As Boolean Implements HomeSeerAPI.IPlugInAPI.SupportsMultipleInstancesSingleEXE
        Return False
    End Function

    Public Function TriggerBuildUI(sUnique As String, TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As String Implements HomeSeerAPI.IPlugInAPI.TriggerBuildUI
        Return Nothing
    End Function

    Public ReadOnly Property TriggerConfigured(TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As Boolean Implements HomeSeerAPI.IPlugInAPI.TriggerConfigured
        Get
            Return False
        End Get
    End Property

    Public ReadOnly Property TriggerCount As Integer Implements HomeSeerAPI.IPlugInAPI.TriggerCount
        Get
            Return 0
        End Get
    End Property

    Public Function TriggerFormatUI(TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As String Implements HomeSeerAPI.IPlugInAPI.TriggerFormatUI
        Return Nothing
    End Function

    Public ReadOnly Property TriggerName(TriggerNumber As Integer) As String Implements HomeSeerAPI.IPlugInAPI.TriggerName
        Get
            Return Nothing
        End Get
    End Property

    Public Function TriggerProcessPostUI(PostData As System.Collections.Specialized.NameValueCollection, TrigInfoIN As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As HomeSeerAPI.IPlugInAPI.strMultiReturn Implements HomeSeerAPI.IPlugInAPI.TriggerProcessPostUI
        Return Nothing
    End Function

    Public Function TriggerReferencesDevice(TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo, dvRef As Integer) As Boolean Implements HomeSeerAPI.IPlugInAPI.TriggerReferencesDevice
        Return Nothing
    End Function

    Public Function TriggerTrue(TrigInfo As HomeSeerAPI.IPlugInAPI.strTrigActInfo) As Boolean Implements HomeSeerAPI.IPlugInAPI.TriggerTrue
        Return False
    End Function
End Class
