﻿Public Class frmScriptExport
    Private Sub frmScriptExport_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.tmrStart.Start()
    End Sub
    Private Sub tmrStart_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrStart.Tick
        Me.tmrStart.Stop()
        Me.cboFiles.SelectedIndex = theMainForm.cboFiles.SelectedIndex
        '' Put Export Directory to text box
        Me.txtExportDirectory.Text = My.Settings.ExportDirectory
    End Sub
    Private Sub clbScripts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles clbScripts.SelectedIndexChanged
        Dim s As String

        s = Me.clbScripts.Items(Me.clbScripts.SelectedIndex).ToString       'selected script name
        Me.lblScript.Text = s
        Me.txtScript.Text = ""
        For Each l As String In Exports(s)
            Me.txtScript.Text = Me.txtScript.Text & l & vbCrLf
        Next
    End Sub
    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClearAll.Click
        For i As Integer = 0 To Me.clbScripts.Items.Count - 1
            Me.clbScripts.SetItemCheckState(i, CheckState.Unchecked)
        Next
    End Sub
    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Close()
    End Sub
    Private Sub btnSelectAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSelectAll.Click
        For i As Integer = 0 To Me.clbScripts.Items.Count - 1
            Me.clbScripts.SetItemCheckState(i, CheckState.Checked)
        Next
    End Sub
    Private Sub btnExportScripts_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExportScripts.Click
        Dim s, p, m As String
        Dim aScript(5) As String
        Dim SomeChecked As Boolean = False

        '' Save export directory
        If Me.txtExportDirectory.Text.Substring(Me.txtExportDirectory.Text.Length - 1) <> "\" Then
            Me.txtExportDirectory.Text = Me.txtExportDirectory.Text & "\"
        End If
        My.Settings.ExportDirectory = Me.txtExportDirectory.Text
        My.Settings.Save()
        p = Me.txtExportDirectory.Text
        m = "The following scripts have been exported to " & Me.txtExportDirectory.Text & ":" & vbCrLf & vbCrLf
        theMainForm.MyLog(m)
        '' Loop through all selected Scripts
        For i As Integer = 0 To Me.clbScripts.Items.Count - 1
            If Me.clbScripts.GetItemChecked(i) Then
                SomeChecked = True
                '' Export this Script
                s = Me.clbScripts.Items(i).ToString
                For j As Integer = 0 To Exports(s).Count - 1
                    ReDim Preserve aScript(j)
                    aScript(j) = Exports(s)(j)
                Next j
                Try
                    IO.File.WriteAllLines(p & s & ".vb", aScript)
                    m = m & "      " & s & ".vb" & vbCrLf
                    theMainForm.MyLog("      " & s & ".vb")
                Catch ex As Exception
                    MsgBox("Could not Export to " & p & s & ".vb" & vbCrLf & ex.Message)
                End Try
            End If
        Next
        If SomeChecked Then
            MsgBox(m, , "tenScripting Export")
        Else
            MsgBox("NO SCRIPTS SELECTED FOR EXPORT", , "tenScripting Export")
        End If
    End Sub

    Private Sub cboFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFiles.SelectedIndexChanged
        Dim sFile, dFile As String, Found As Boolean

        Me.clbScripts.Items.Clear()
        sFile = Me.cboFiles.Items(Me.cboFiles.SelectedIndex)
        For Each sd As ScriptData In Scripts.Values
            dFile = IO.Path.GetFileName(sd.Filename)
            If dFile = sFile Then
                '' Only add if not there already (multiple methods for same class)
                Found = False
                For Each s As String In Me.clbScripts.Items
                    If s = sd.ClassName Then
                        Found = True
                        Exit For
                    End If
                Next
                If Not Found Then Me.clbScripts.Items.Add(sd.ClassName)
            End If
        Next
    End Sub
End Class