﻿Imports Scheduler
Imports HomeSeerAPI

Imports HSCF.Communication.Scs.Communication.EndPoints.Tcp
Imports HSCF.Communication.ScsServices.Client
Imports HSCF.Communication.ScsServices.Service

Imports System.Reflection
'Delegate Sub UpdateDevicesDelegate(ByVal parms() As Object)
Delegate Sub UpdateDevicesDelegate(ByVal p As String)




Public Class tenScripting
    Public WithEvents client As HSCF.Communication.ScsServices.Client.IScsServiceClient(Of IHSApplication)
    Dim WithEvents clientCallback As HSCF.Communication.ScsServices.Client.IScsServiceClient(Of IAppCallbackAPI)

    Private host As HomeSeerAPI.IHSApplication
    Public plugin As HSPI                               ' real plugin functions, user supplied
    Friend FreezeEvents As Boolean = False
    Friend FreezeLog As Boolean = False
    Friend ScriptingLog As Boolean = False
    Friend ScriptTable As ArrayList
    Friend DebugLogProccess As Process



    Private Sub frmMain_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        StartupComplete = False
        tmrStartup.Start()
    End Sub
    Private Sub client_Disconnected(ByVal sender As Object, ByVal e As System.EventArgs) Handles client.Disconnected
        Console.WriteLine("tenScripting has been disconnected from HS3")
    End Sub
    Private Sub wait(ByVal secs As Integer)
        Threading.Thread.Sleep(secs * 1000)
    End Sub

    Private Sub tmrStartup_Tick(sender As System.Object, e As System.EventArgs) Handles tmrStartup.Tick
        tmrStartup.Stop()
        ''
        '' Handle All Program Initialization in Timer Event, After frmMain has loaded
        ''
        ''
        ''     First, Connect to HS3
        ''
        Dim sIp As String, rc As Boolean
        Dim Attempts As Integer
        sIp = My.Settings.HsComputer
        MyLog("Plugin: " & IFACE_NAME & " Instance: " & Instance & " starting...")

        plugin = New HSPI
        client = ScsServiceClientBuilder.CreateClient(Of IHSApplication)(New ScsTcpEndPoint(sIp, 10400), plugin)
        clientCallback = ScsServiceClientBuilder.CreateClient(Of IAppCallbackAPI)(New ScsTcpEndPoint(sIp, 10400), plugin)

        Attempts = 1

TryAgain:
        Try
            MyLog("Connecting to server at " & sIp & "...")
            client.Connect()
            clientCallback.Connect()

            host = client.ServiceProxy
            Dim APIVersion As Double = host.APIVersion  ' will cause an error if not really connected
            Console.WriteLine("client ApiVersion: " & APIVersion.ToString)
            callback = clientCallback.ServiceProxy
            APIVersion = callback.APIVersion  ' will cause an error if not really connected
            Console.WriteLine("callback ApiVersion: " & APIVersion.ToString)
        Catch ex As Exception
            Console.WriteLine("Cannot connect attempt " & Attempts.ToString & ": " & ex.Message)
            MyLog("Cannot connect attempt " & Attempts.ToString & ": " & ex.Message)
            If ex.Message.ToLower.Contains("timeout occurred.") Then
                Attempts += 1
                If Attempts < 1 Then GoTo TryAgain
            End If
            frmConnection.ShowDialog()
            If client IsNot Nothing Then
                client.Dispose()
                client = Nothing
            End If
            If clientCallback IsNot Nothing Then
                clientCallback.Dispose()
                clientCallback = Nothing
            End If
            wait(4)
            Return
        End Try

        Try
            ' connect to HS so it can register a callback to us
            rc = host.Connect(IFACE_NAME, Instance)
            Console.WriteLine("host connect result: " & rc.ToString)
            ' create the user object that is the real plugin, accessed from the pluginAPI wrapper
            callback = callback
            hs = host
            'plugin.OurInstanceFriendlyName = Instance
            MyLog("Connected, waiting to be initialized...")
            
        Catch ex As Exception
            MyLog("Cannot connect(2): " & ex.Message)
            wait(2)
            End
            Return
        End Try
        ''
        '' Connected, Start tenScripting Initialization
        ''
        MyLog("tenScripting Starting")
        '' Upgrade Settings from Last Release if this is a New Release
        If My.Settings.UpgradeSettings Then
            My.Settings.Upgrade()
            My.Settings.UpgradeSettings = False
            My.Settings.Save()
            MyLog("New Version Detected.  Settings copied from prior version.")
        End If
        theMainForm = Me
        Me.lblDeviceName.Text = ""
        chkProcessAsHsParms.Checked = My.Settings.ProcessAsHsParms
        My.Settings.TriggersEnabled = False : My.Settings.Save()
        Me.chkTriggers.Checked = My.Settings.TriggersEnabled
        Me.btnTriggers.Visible = Not My.Settings.TriggersEnabled
        '' Set up Triggers data
        GetTriggers()
        '' Gather information about scripts
        GetScripts()
        Me.btnTriggers.Visible = True
        Me.MenuStrip1.Visible = True

        '' Turn HS Debug Logging ON ?
        If My.Settings.DebugLoggingEnabled Then
            DeleteDebugLog()
            hs.DebugMode = 15
            Me.btnDebugLogs.Visible = True
        End If
        hsp = CType(hs.GetHSPRef, Scheduler.hsp)            'HS Phone
        MyLog("Homeseer Connection Successful")
        Me.lblConnected.Text = "Connected"
        Me.picHS.Visible = True
        Me.Refresh()
        Me.btnRunSubMain.Enabled = True
        'Result2 = hsinterface.RegisterEventCB(&HE52, Me)
        'If Result2 <> "" Then
        '    MyLog("RegisterEventCB Failed:" & Result2)
        'End If
        ' hs.WriteLog("tenScripting", "Connection Successful")



        StartupComplete = True
        MyLog("tenScripting Initialization Complete")
        ''
        '' Wait for tenScripting to Finish
        ''
        Do
            Threading.Thread.Sleep(10)
            Application.DoEvents()
        Loop While client.CommunicationState = HSCF.Communication.Scs.Communication.CommunicationStates.Connected And Not HSPI.bShutDown
        Console.WriteLine("Connection to HS3 lost, tenScripting is exiting")
        ' disconnect from server for good here
        client.Disconnect()
        clientCallback.Disconnect()
        wait(2)
        End







    End Sub

    Private Sub GetScripts()
        Dim anAssembly As Assembly
        Dim modules() As System.Reflection.Module, aModule As [Module]
        Dim methodinfos() As MethodInfo
        Dim types() As Type
        Dim sd As ScriptData
        Dim DI As IO.DirectoryInfo, FIs() As IO.FileInfo, FI As IO.FileInfo
        Dim ed, p As String, i As Integer
        Dim Excludes() As String = {"FRMCONNECTION.DESIGNER.VB", _
            "FRMCONNECTION.VB", _
            "FRMDEBUGSETTINGS.DESIGNER.VB", _
            "FRMDEBUGSETTINGS.VB", _
            "FRMSCRIPTEXPORT.DESIGNER.VB", _
            "FRMSCRIPTEXPORT.VB", _
            "TENSCRIPTING.DESIGNER.VB", _
            "TENSCRIPTING.VB", _
            "FRMWEBPORT.VB", _
            "FRMWEBPORT.DESIGNER.VB", _
            "FRMWEBPORT.DESIGNER.VB", _
            "HSPI.VB", _
            "UTIL.VB", _
            "FRMTRIGGERS.VB", "FRMTRIGGERS.DESIGNER.VB"}

        '' Get all of the Files, Classes, Methods from the VS Project Files
        ed = My.Application.Info.DirectoryPath          'executable directory
        i = ed.IndexOf("bin")                           'offset to project sub directory
        p = ed.Substring(0, i)                          'path to project sub directory
        DI = New IO.DirectoryInfo(p)
        FIs = DI.GetFiles
        Exports.Clear()                                 'clear target list of scripts
        For Each FI In FIs
            If FI.Extension.ToUpper = ".VB" Then
                i = Array.IndexOf(Excludes, FI.Name.ToUpper)
                If Array.IndexOf(Excludes, FI.Name.ToUpper) = -1 Then
                    Me.cboFiles.Items.Add(FI.Name)
                    'MyLog("Found Source File " & FI.Name.ToUpper)
                    GetClasses(FI.FullName)
                End If
            End If
        Next
        If Me.cboFiles.Items.Count > 0 Then
            '' Determine File Selection
            Me.cboFiles.SelectedIndex = 0
            For i = 0 To Me.cboFiles.Items.Count - 1
                If Me.cboFiles.Items(i) = My.Settings.LastFile Then
                    Me.cboFiles.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboFiles.Refresh()

        '' Get all of the Methods Loaded into Memory
        anAssembly = Assembly.GetExecutingAssembly()
        modules = anAssembly.GetLoadedModules()
        aModule = modules(0)
        types = aModule.GetTypes()
        For Each t As Type In types
            methodinfos = t.GetMethods
            For Each m As MethodInfo In methodinfos
                If Scripts.ContainsKey(t.Name & "." & m.Name) Then
                    sd = Scripts(t.Name & "." & m.Name)
                    sd.oType = t
                    'MyLog("Loaded Method " & sd.ClassName.ToUpper & "." & sd.MethodName.ToUpper)
                End If
            Next
        Next
    End Sub
    Friend Sub GetClasses(ByVal fn As String)
        Dim sr As IO.StreamReader, ClassStatements As Specialized.StringCollection
        Dim ClassName As String
        Dim l As String, Imps As New Specialized.StringCollection

        '' Open Script File
        sr = IO.File.OpenText(fn)                        'open the Scripts.vb file
        '' Loop through Source file
        Do While Not sr.EndOfStream
            '' Look for start of Class definition
            l = sr.ReadLine()
            If l.Trim.ToUpper.Length > 6 Then
                If l.Trim.ToUpper.Substring(0, 7) = "IMPORTS" Then
                    '' Save IMPORTS statement to add to each class/script in the file
                    Imps.Add(l)
                End If
            End If
            If l.Trim.ToUpper.Contains("CLASS ") Then
                '' Found a Class definition
                ClassStatements = New Specialized.StringCollection
                '' Save the Class Name
                ClassName = l.Substring(l.ToUpper.IndexOf("CLASS") + 6).Trim
                '' Look for End of Class definition
                Do
                    l = sr.ReadLine
                    If l.Trim.ToUpper.Contains("END CLASS") Then Exit Do
                    ClassStatements.Add(l)              'add a line of the definition
                Loop
                '' Have accumulated the Class definition, add it to collection
                For Each s As String In Imps
                    '' Insert the saved IMPORTS statements
                    ClassStatements.Insert(0, s)
                Next
                Try
                    Exports.Add(ClassName, ClassStatements)
                Catch ex As Exception
                    MyLog("Exception Processing Class: " & ClassName)
                    MyLog("Suspect you have defined the Class more than once")
                    MyLog("This could be duplicates in multiple files in the project directory, even if they are not defined in the project itself.")
                    MyLog("Script Processing Truncated")
                    MyLog("Exception: " & ex.Message)
                End Try
                'MyLog("--Found Class " & ClassName.ToUpper)
                GetMethods(fn, ClassName)
            End If
        Loop
        sr.Close()
        sr = Nothing
    End Sub
    Friend Sub GetMethods(ByVal fn As String, ByVal cn As String)
        Dim ClassStatements As Specialized.StringCollection
        Dim i As Integer, MethodName As String
        Dim sd As ScriptData

        ClassStatements = Exports(cn)                               ' fetch all of the statements in the class
        i = 0
        Do
            '' Loop through class statements
            If i > ClassStatements.Count - 1 Then Exit Do
            If ClassStatements(i).Trim.ToUpper.Contains("SUB ") And ClassStatements(i).Trim.ToUpper.Contains("PUBLIC ") Then
                '' Found a Method definition
                MethodName = ClassStatements(i).Substring(ClassStatements(i).ToUpper.IndexOf("SUB") + 4).Trim
                MethodName = MethodName.Substring(0, MethodName.IndexOf("(")).Trim
                'MyLog("----Found Sub " & MethodName.ToUpper)
                sd = New ScriptData(fn, cn, MethodName, Me.GetType)
                Scripts.Add(sd.ClassName & "." & sd.MethodName, sd)
                '' Look for End of Class definition
                i = i + 1
                Do
                    If ClassStatements(i).Trim.ToUpper.Contains("END SUB") Then Exit Do
                    i = i + 1
                Loop
            End If
            i = i + 1
        Loop
    End Sub
    Private Sub btnConnectToHomeseer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' ConnectToHomeseer()
    End Sub
    'Private Sub ConnectToHomeseer()
    '    Dim Result, Result2 As String
    '    Dim ConnectForm As frmConnection
    '    Dim ip As String

    '    Try
    '        '' Attempt to connect to Homeseer
    '        Me.lblConnected.Text = ".. Connecting .."
    '        Me.Refresh()
    '        hsinterface = New HomeSeer2.application
    '        ip = My.Settings.HsComputer
    '        If My.Settings.HsPort.Length > 0 Then ip = ip & ":" & My.Settings.HsPort
    '        hsinterface.SetHost(ip)
    '        Result = hsinterface.Connect(My.Settings.HsUsername, My.Settings.HsPassword)
    '        If Result = "" Then
    '            hs = hsinterface.GetHSRef
    '            '' Turn HS Debug Logging ON ?
    '            If My.Settings.DebugLoggingEnabled Then
    '                DeleteDebugLog()
    '                hs.DebugMode = 15
    '                Me.btnDebugLogs.Visible = True
    '            End If
    '            hsp = CType(hs.GetHSPRef, Scheduler.hsp)            'HS Phone
    '            MyLog("Homeseer Connection Successful")
    '            Me.lblConnected.Text = "Connected"
    '            Me.picHS.Visible = True
    '            Me.Refresh()
    '            Me.btnRunSubMain.Enabled = True
    '            Result2 = hsinterface.RegisterEventCB(&HE52, Me)
    '            If Result2 <> "" Then
    '                MyLog("RegisterEventCB Failed:" & Result2)
    '            End If
    '            hs.WriteLog("tenScripting", "Connection Successful")
    '            Exit Sub
    '        End If
    '        Me.lblConnected.Text = "Connection Failed"
    '        Me.Refresh()
    '        hsinterface = Nothing
    '        ConnectForm = New frmConnection
    '        ConnectForm.ShowDialog()
    '        ConnectForm = Nothing
    '        Me.Close()
    '    Catch ex As Exception
    '        MsgBox(ex.Message)
    '        Me.Close()
    '    End Try
    'End Sub
    Friend Sub DeleteDebugLog()
        Dim dir As String

        dir = My.Settings.DebugLogPath
        If dir.Substring(dir.Length - 1, 1) <> "\" Then dir = dir & "\"
        If IO.Directory.Exists(dir) Then
            '' Found Directory
            If IO.File.Exists(dir & "Debug_Composite.Log") Then
                IO.File.Delete(dir & "Debug_Composite.Log")
                MyLog("Deleted: " & dir & "Debug_Composite.Log")
            End If
        Else
            '' Directory Not Found
            MyLog("Debug Log Directory Not Found: " & dir)
        End If
    End Sub
    Public Sub UpdateDevices(ByVal p As String)
        Dim dc, ds As String
        Dim i As Integer, a As String, dt As Date
        Dim PossibleStatus As String() = {"", "", "On", "Off", "Dim", "Dim", "", "", "", "", "", "", "", "", "", "", "", "Unknown"}
        Dim sd As ScriptData
        Dim parms() As String
        ''
        '' UpdateDevices is called for each Event received from HS   (HSPI.HsEvent)
        ''
        '' Get individual parms from string
        parms = p.Split(Chr(2))
        '' Check if this matches a Trigger
        dt = Now
        ds = Format(dt, "mm:ss")
        dc = ""
        i = CType(parms(0), Integer)
        Select Case i
            Case &H2
                '' Log Record
                a = parms(2).ToString
                lstHomeseerLog.Items.Add(Format(ln Mod 100, "00 ") & ds & " | " & a & " | " & parms(3))
                ln = ln + 1
                If Not Me.FreezeLog Then
                    lstHomeseerLog.SelectedIndex = lstHomeseerLog.Items.Count - 1
                    lstHomeseerLog.Refresh()
                End If
            Case &H40
                '' String Change
                dc = parms(1).ToString
                Me.lstChanges.Items.Add(Format(ln Mod 100, "00 ") & ds & dc & ") New DeviceString=" & parms(2).ToString)
                ln = ln + 1
                If Not Me.FreezeEvents Then
                    Me.lstChanges.SelectedIndex = Me.lstChanges.Items.Count - 1
                    Me.lstChanges.Refresh()
                End If
            Case &H400
                '' Value Change
                dc = parms(4)      ' Device Ref Number
                Me.lstChanges.Items.Add(Format(ln Mod 100, "00 ") & ds & " (" & dc & ") Old Value=" & parms(3).ToString & "  New Value=" & parms(2).ToString)
                ln = ln + 1
                If Not Me.FreezeEvents Then
                    Me.lstChanges.SelectedIndex = Me.lstChanges.Items.Count - 1
                    Me.lstChanges.Refresh()
                End If
                '' Check if active filter should trigger a script
                If My.Settings.TriggersEnabled Then
                    dc = parms(4).ToUpper.Trim          ' string of Device Ref
                    '' Value or Status Change, so look for a matching trigger
                    For Each t As TriggerData In Triggers
                        If t.Device.ToUpper.Trim = dc.ToUpper.Trim Then
                            '' Found a trigger for this device
                            If Scripts.ContainsKey(t.Script & "." & t.Method) Then
                                sd = Scripts(t.Script & "." & t.Method)
                                sd.Parms = t.Parms
                                SyncLock qTriggers
                                    qTriggers.Enqueue(sd)
                                End SyncLock
                                MyLog("Device Triggered for:" & dc & " " & t.Script & "." & t.Method)
                            Else
                                MyLog("SCRIPT TRIGGER METHOD MISSING: " & t.Script & "." & t.Method)
                            End If
                        End If
                    Next
                End If


            Case Else
                '' HsEvent we are not interested in
        End Select
    End Sub
    Private Sub SetRunButtonText()
        Dim s, p As String

        '' Get Script name
        If Me.cboMethods.Items.Count > 0 Then
            s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex) & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        Else
            s = ""
        End If
        '' Get parms
        p = """" & Me.txtParms.Text & """"
        Me.btnRunSubMain.Text = s & "(" & p & ")"
    End Sub
    Private Sub btnRunSubMain_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRunSubMain.Click
        Dim s, p As String
        Dim ss(0) As Object
        Dim sss() As String
        Me.tmrTriggers.Stop()
        '' Save the Selection Boxes
        My.Settings.LastFile = Me.cboFiles.Items(Me.cboFiles.SelectedIndex)
        My.Settings.LastClass = Me.cboClasses.Items(Me.cboClasses.SelectedIndex)
        My.Settings.LastMethod = Me.cboMethods.Items(Me.cboMethods.SelectedIndex)
        My.Settings.Save()

        '' Save the Parms for this Script
        s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        '''' Remove any existing entry
        For i As Integer = 0 To My.Settings.Parms.Count - 1
            p = My.Settings.Parms(i)
            If s.Length + 1 <= p.Length Then
                If p.Substring(0, s.Length + 1).ToUpper = s.ToUpper & "=" Then
                    My.Settings.Parms.RemoveAt(i)
                    Exit For
                End If
            End If
        Next i
        '''' Now save the current parm
        My.Settings.Parms.Add(s.ToUpper & "=" & Me.txtParms.Text.ToString)
        My.Settings.Save()
        '' Get the Parms
        s = Me.txtParms.Text.ToString
        If My.Settings.ProcessAsHsParms Then
            '' Process as HS parms: Only single parm, truncates at ","
            If s.IndexOf(",") >= 0 Then
                s = s.Substring(0, s.IndexOf(","))
            End If
            ss(0) = s
        Else
            '' Process as normal parms (HsTouch for Example): Parms separated by ","
            sss = s.Split(",")
            ss(0) = sss
        End If
        '' Run the Script
        RunScript(Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString, Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString, ss)
        Me.tmrTriggers.Start()
    End Sub
    Friend Sub RunScript(ByVal pClass As String, ByVal pMethod As String, ByVal pParms() As Object)
        Dim anObj As Object, t As Type
        'Dim Args() As Object
        Dim s As String
        Dim sd As ScriptData

        If pMethod.ToUpper = "MAIN" And pMethod <> "Main" Then
            MyLog("Warning:  Method name= " & pMethod & "   HS will only find 'Main' as a default method")
            MsgBox("Warning:  Method name= " & pMethod & "   HS will only find 'Main' as a default method", , "tenScripting")
        End If

        '' Hide the Debug Button
        Me.btnDebugLogs.Visible = False
        Me.lblScriptRunning.Visible = True
        Me.lblScriptRunning.Refresh()

        '' Create instance of class containing script to run
        s = pClass & "." & pMethod
        sd = Scripts(s)
        t = sd.oType
        anObj = Activator.CreateInstance(t)
        '' Get the Parms
        'Args = New Object(0) {}
        'Args(0) = pParms(0)
        '' Log we are now running a script
        MyLog("Running " & sd.ClassName & "." & sd.MethodName)
        hs.WriteLog("tenScripting", ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Debug Started for " & sd.ClassName & "." & sd.MethodName)
        '' Run the Script
        Try
            t.InvokeMember(sd.MethodName, BindingFlags.InvokeMethod Or BindingFlags.Instance Or _
                BindingFlags.Public Or BindingFlags.IgnoreCase, _
                Nothing, anObj, pParms, Nothing, Nothing, Nothing)
        Catch ex As Exception
            MyLog(">>> Exception")
            MyLog(">>> " & ex.Message)
            If Not IsNothing(ex.InnerException) Then
                MyLog(">>>>> " & ex.InnerException.Message)
                MyLog(">>>>> " & ex.InnerException.StackTrace)
            End If
            Beep()
            MsgBox("Execution Error in " & sd.ClassName & "." & sd.MethodName & ", see tenScripting Log")
        Finally
            hs.WriteLog("tenScripting", ">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Debug Ended for " & _
                sd.ClassName & "." & sd.MethodName)
            Me.lblScriptRunning.Visible = False
            Me.btnDebugLogs.Visible = My.Settings.DebugLoggingEnabled
        End Try
        MyLog(sd.ClassName & "." & sd.MethodName & " Finished")
    End Sub

    Private Sub txtParms_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtParms.TextChanged
        SetRunButtonText()
    End Sub
    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Me.Close()
    End Sub
    Private Sub ExittenScripting()
        '' Turn OFF HS Debug Logging
        HSPI.bShutDown = True
        MyLog("tenScripting Closing")
        hs.WriteLog("tenScripting", "tenScripting Closing")
        hs.DebugMode = 0
        'If Not IsNothing(hsinterface) Then
        '    hsinterface.Disconnect()
        '    hsinterface = Nothing
        'End If
        If Not IsNothing(hs) Then
            hs = Nothing
        End If
        If Not IsNothing(hsp) Then
            hsp = Nothing
        End If

    End Sub
    Private Sub ExportScriptsToolStripMenuItem_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExportScriptsToolStripMenuItem.Click
        Dim ExportForm As frmScriptExport

        '' Display the Script Export Form
        ExportForm = New frmScriptExport
        For Each s As String In Me.cboFiles.Items
            ExportForm.cboFiles.Items.Add(s)
        Next
        ExportForm.ShowDialog()
        ExportForm = Nothing
    End Sub
    Private Sub DonationToCysticFibrosisFoundationToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Dim p As String

        p = "http://www.tenholder.net/CharityWare/"
        Process.Start(p)
    End Sub
    Private Sub MainForm_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Me.ExittenScripting()
    End Sub
    Private Sub mnuHsLogSettings_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuHsLogSettings.Click
        Dim f As frmDebugSettings

        f = New frmDebugSettings
        f.chkEnableDebugLog.Checked = My.Settings.DebugLoggingEnabled
        f.txtDebugLogPath.Visible = My.Settings.DebugLoggingEnabled
        f.lblDebugLogPath.Visible = My.Settings.DebugLoggingEnabled
        f.txtDebugLogPath.Text = My.Settings.DebugLogPath
        f.ShowDialog()
        Me.btnDebugLogs.Visible = My.Settings.DebugLoggingEnabled
        If My.Settings.DebugLoggingEnabled Then
            hs.DebugMode = 15
        Else
            hs.DebugMode = 0
        End If
        f = Nothing
    End Sub
    Private Sub CFFToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CFFToolStripMenuItem.Click
        Dim p As String

        p = "http://www.tenholder.net/tenWare2/CharityWare.aspx"
        Process.Start(p)
    End Sub
    Private Sub ConnectionToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectionToolStripMenuItem.Click
        Dim ConnectForm As frmConnection

        ConnectForm = New frmConnection
        ConnectForm.ShowDialog()
        ConnectForm = Nothing
    End Sub
    Private Sub cboScripts_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboMethods.SelectedIndexChanged
        Dim s As String

        '' Get selected Script
        s = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString & "." & Me.cboMethods.Items(Me.cboMethods.SelectedIndex).ToString
        Me.txtParms.Text = ""
        For Each p As String In My.Settings.Parms
            '' Check if Parms are stored for this Script
            If s.Length + 1 <= p.Length Then
                If p.Substring(0, s.Length + 1).ToUpper = s.ToUpper & "=" Then
                    '' Place Parms into control
                    Me.txtParms.Text = p.Substring(s.Length + 1)
                    Exit For
                End If
            End If
        Next
        SetRunButtonText()
    End Sub
    Private Sub lstChanges_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstChanges.SelectedIndexChanged
        Dim a, b As String, i As Integer
        Dim d As Scheduler.Classes.DeviceClass

        a = Me.lstChanges.Items(Me.lstChanges.SelectedIndex).ToString       ' get selected list entry
        '' Get Dev from list entry
        i = a.IndexOf(")")
        b = a.Substring(10, i - 10)
        ' i = hs.GetDeviceRef(b)
        d = hs.GetDeviceByRef(CInt(b))
        '' Display info about selected device
        Try
            Me.lblDeviceName.Text = b & ": " & d.Location2(hs) & " " & d.Location(hs) & " " & d.Name(hs)
        Catch ex As Exception
            Me.lblDeviceName.Text = ""
        End Try
    End Sub
    Private Sub btnFreeze_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreeze.Click
        If Me.btnFreeze.Text = "Freeze" Then
            Me.btnFreeze.Text = "Scroll"
            Me.FreezeEvents = True
        Else
            Me.btnFreeze.Text = "Freeze"
            Me.FreezeEvents = False
        End If
    End Sub
    Private Sub cboFiles_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboFiles.SelectedIndexChanged
        Dim cFile, dFile As String, Found As Boolean

        cFile = Me.cboFiles.Items(Me.cboFiles.SelectedIndex).ToString.ToUpper
        Me.cboClasses.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dFile = IO.Path.GetFileName(sd.Filename).ToUpper
            If dFile = cFile Then
                '' Only add if not there already (multiple methods for same class)
                Found = False
                For Each s As String In cboClasses.Items
                    If s = sd.ClassName Then
                        Found = True
                        Exit For
                    End If
                Next
                If Not Found Then Me.cboClasses.Items.Add(sd.ClassName)
            End If
        Next
        If Me.cboClasses.Items.Count > 0 Then
            '' Determine Class Selection
            Me.cboClasses.SelectedIndex = 0
            For i As Integer = 0 To Me.cboClasses.Items.Count - 1
                If Me.cboClasses.Items(i) = My.Settings.LastClass Then
                    Me.cboClasses.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboClasses.Refresh()
    End Sub
    Private Sub cboClasses_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboClasses.SelectedIndexChanged
        Dim cClass, dClass As String

        cClass = Me.cboClasses.Items(Me.cboClasses.SelectedIndex).ToString.ToUpper
        Me.cboMethods.Items.Clear()
        For Each sd As ScriptData In Scripts.Values
            dClass = IO.Path.GetFileName(sd.ClassName).ToUpper
            If dClass = cClass Then
                Me.cboMethods.Items.Add(sd.MethodName)
            End If
        Next
        If Me.cboMethods.Items.Count > 0 Then
            '' Determine Method Selection
            Me.cboMethods.SelectedIndex = 0
            For i As Integer = 0 To Me.cboMethods.Items.Count - 1
                If Me.cboMethods.Items(i) = My.Settings.LastMethod Then
                    Me.cboMethods.SelectedIndex = i
                    Exit For
                End If
            Next
        End If
        Me.cboMethods.Refresh()
    End Sub
    Private Sub TenScriptingWebSiteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TenScriptingWebSiteToolStripMenuItem.Click
        ''
        '' Display tenScripting Web Site in Browser
        ''
        Dim p As String

        p = "http://www.tenholder.net/tenWare2/tenScripting"
        Process.Start(p)
    End Sub

    Private Sub SetHomeSeerWebPortToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ''
        '' Display Dialog for User to Set Port for HomeSeer Web Server
        ''
        Dim f As frmWebPort

        f = New frmWebPort
        f.txtPort.Text = My.Settings.WebServerPort
        f.lblPort1.Text = "http://" & My.Settings.HsComputer & ":"
        f.txtPort.Left = f.lblPort1.Right + 0
        f.lblPort2.Left = f.txtPort.Right + 0
        f.ShowDialog()
        My.Settings.WebServerPort = f.txtPort.Text
        My.Settings.Save()
        f = Nothing
    End Sub
    Private Sub HomeSeerHelpFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeSeerHelpFileToolStripMenuItem.Click
        ''
        '' Display HomeSeer Help File in Browser
        ''
        Dim p As String

        p = "http://homeseer.com/support/homeseer/HS3/scripting/default.htm"
        Process.Start(p)
    End Sub
    Private Sub HomeSeerSDKToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HomeSeerSDKToolStripMenuItem.Click
        ''
        '' Display HomeSeer SDK in Browser
        ''
        Dim p As String

        p = "http://homeseer.com/support/homeseer/HS3/SDK/default.htm"
        Process.Start(p)
    End Sub
    Private Sub btnFreezeLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFreezeLog.Click
        If Me.btnFreezeLog.Text = "Freeze" Then
            Me.btnFreezeLog.Text = "Scroll"
            Me.FreezeLog = True
        Else
            Me.btnFreezeLog.Text = "Freeze"
            Me.FreezeLog = False
        End If
    End Sub
    Private Sub btnScriptingLog_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnScriptingLog.Click
        If Me.btnScriptingLog.Text = "Freeze" Then
            Me.btnScriptingLog.Text = "Scroll"
            Me.ScriptingLog = True
        Else
            Me.btnScriptingLog.Text = "Freeze"
            Me.ScriptingLog = False
        End If
    End Sub
    Private Sub picHS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles picHS.Click
        ''
        '' Display HomeSeer Status Page
        ''
        Dim p As String

        p = "http://" & My.Settings.HsComputer & ":" & My.Settings.HsPort
        Process.Start(p)
    End Sub
    Private Sub btnDebugLogs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDebugLogs.Click
        ''
        '' Display HomeSeer Debug Log
        ''
        Dim dir As String

        dir = My.Settings.DebugLogPath
        If dir.Substring(dir.Length - 1, 1) <> "\" Then dir = dir & "\"
        If IO.File.Exists(dir & "Debug_Composite.Log") Then
            '' File Exists
            If Me.DebugLogProccess Is Nothing Then
                '' Notepad not already open
                Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
            Else
                If Not Me.DebugLogProccess.HasExited Then
                    '' Notepad still running
                    Me.DebugLogProccess.Kill()
                    Me.DebugLogProccess = Nothing
                    Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
                Else
                    Me.DebugLogProccess = Nothing
                    Me.DebugLogProccess = Process.Start("Notepad.exe", dir & "Debug_Composite.Log")
                End If
            End If
        Else
            '' File does not exist
            MyLog("Could not find Debug Log: " & dir & "Debug_Composite.Log")
        End If
    End Sub

    Private Sub lstHomeseerLog_DrawItem(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles lstHomeseerLog.DrawItem
        Dim textBrush As Brush
        Dim drawFont As Font

        If lstHomeseerLog.Items.Count < 1 Or e.Index < 0 Then Exit Sub
        drawFont = e.Font
        e.DrawBackground()
        If Me.lstHomeseerLog.Items(e.Index).ToString.Contains("tenScripting") Then
            textBrush = Brushes.Red
            drawFont = New Font(drawFont.FontFamily, drawFont.Size, FontStyle.Regular)
        Else
            textBrush = Brushes.Black
        End If
        e.Graphics.DrawString(lstHomeseerLog.Items.Item(e.Index).ToString(), drawFont, textBrush, e.Bounds.X, e.Bounds.Y)
    End Sub

    Private Sub chkTriggers_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkTriggers.CheckedChanged
        My.Settings.TriggersEnabled = Me.chkTriggers.Checked
        My.Settings.Save()
        'Me.btnRunSubMain.Visible = Not My.Settings.TriggersEnabled
        'Me.lblClickToRun.Visible = Not My.Settings.TriggersEnabled
        Me.btnTriggers.Visible = Not My.Settings.TriggersEnabled
        If My.Settings.TriggersEnabled Then
            MyLog("Monitoring Device Triggers")
            Me.tmrTriggers.Start()
        Else
            MyLog("Device Trigger Monitoring Stopped")
        End If
    End Sub

    Private Sub btnTriggers_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnTriggers.Click
        '' Display Triggers Dialog
        Dim f As frmTriggers

        f = New frmTriggers
        '' Populate the File Drop Down List
        For Each s As String In Me.cboFiles.Items
            f.cboFile.Items.Add(s)
        Next
        If f.cboFile.Items.Count > 0 Then f.cboFile.SelectedIndex = 0
        f.ShowDialog()
        f = Nothing
        SaveTriggers()
    End Sub
    Friend Sub GetTriggers()
        Dim ss() As String
        Dim t As TriggerData
        Dim sc As New System.Collections.Specialized.StringCollection

        sc = My.Settings.Triggers
        If Not sc Is Nothing Then
            If sc.Count > 0 Then
                For Each s As String In sc
                    ss = s.Split(sep)
                    t = New TriggerData(ss(0), ss(1), ss(2), ss(3), ss(4), ss(5))
                    Triggers.Add(t)
                Next
            End If
        End If
    End Sub
    Friend Sub SaveTriggers()
        Dim sc As New System.Collections.Specialized.StringCollection
        Dim a As String

        For Each t As TriggerData In Triggers
            a = t.Device & sep & t.Condition & sep & t.File & sep & t.Script & sep & t.Method & sep & t.Parms
            sc.Add(a)
        Next
        My.Settings.Triggers = sc
        My.Settings.Save()
    End Sub

    Private Sub tmrTriggers_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrTriggers.Tick
        Dim sd As ScriptData
        Dim ss(0) As String

        tmrTriggers.Stop()
        '' Check if their are any Triggered Scripts to Run
        If qTriggers.Count > 0 Then
            '' There are queued scripts
            SyncLock qTriggers
                sd = qTriggers.Dequeue              ' get the script info from Q
            End SyncLock
            ss(0) = sd.Parms
            RunScript(sd.ClassName, sd.MethodName, ss)
        End If
        tmrTriggers.Start()
    End Sub

    Private Sub chkProcessAsHsParms_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkProcessAsHsParms.CheckedChanged
        If StartupComplete Then
            My.Settings.ProcessAsHsParms = chkProcessAsHsParms.Checked
            My.Settings.Save()
        End If
    End Sub

    Friend Sub MyLog(ByVal t As String)
        Me.lstLog.Items.Add(Format(ln Mod 100, "00 ") & t)
        ln = ln + 1
        If Not Me.ScriptingLog Then
            Me.lstLog.SelectedIndex = Me.lstLog.Items.Count - 1
            Me.lstLog.Refresh()
        End If
    End Sub

    Private Sub HelpToolStripMenuItem_Click(sender As System.Object, e As System.EventArgs) Handles HelpToolStripMenuItem.Click

    End Sub
End Class





Class ScriptData
    Dim _FileName As String
    Dim _ClassName As String
    Dim _MethodName As String
    Dim _oType As Type
    Dim _Parms As String
    Friend Sub New(ByVal FileName As String, ByVal ClassName As String, ByVal MethodName As String, ByVal oType As Type)
        _FileName = FileName
        _ClassName = ClassName
        _MethodName = MethodName
        _oType = oType
    End Sub
    Friend Property Parms() As String
        Get
            Return _Parms
        End Get
        Set(ByVal value As String)
            _Parms = value
        End Set
    End Property
    Friend ReadOnly Property Filename() As String
        Get
            Return _FileName
        End Get
    End Property
    Friend ReadOnly Property ClassName() As String
        Get
            Return _ClassName
        End Get
    End Property
    Friend ReadOnly Property MethodName() As String
        Get
            Return _MethodName
        End Get
    End Property
    Friend Property oType() As Type
        Get
            Return _oType
        End Get
        Set(ByVal value As Type)
            _oType = value
        End Set
    End Property
End Class
Class TriggerData
    Dim _Device As String
    Dim _Condition As String
    Dim _File As String
    Dim _Script As String
    Dim _Method As String
    Dim _Parms As String
    Public Sub New(ByVal Device As String, ByVal Condition As String, ByVal File As String, ByVal Script As String, ByVal Method As String, ByVal Parms As String)
        _Device = Device
        _Condition = Condition
        _File = File
        _Script = Script
        _Method = Method
        _Parms = Parms
    End Sub
    Public Property Device() As String
        Get
            Return _Device
        End Get
        Set(ByVal value As String)
            _Device = value
        End Set
    End Property
    Public Property Condition() As String
        Get
            Return _Condition
        End Get
        Set(ByVal value As String)
            _Condition = value
        End Set
    End Property
    Public Property File() As String
        Get
            Return _File
        End Get
        Set(ByVal value As String)
            _File = value
        End Set
    End Property
    Public Property Script() As String
        Get
            Return _Script
        End Get
        Set(ByVal value As String)
            _Script = value
        End Set
    End Property
    Public Property Method() As String
        Get
            Return _Method
        End Get
        Set(ByVal value As String)
            _Method = value
        End Set
    End Property
    Public Property Parms() As String
        Get
            Return _Parms
        End Get
        Set(ByVal value As String)
            _Parms = value
        End Set
    End Property

End Class
